﻿<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
    <title>Customer Map</title>
    <link rel="stylesheet" type="text/css" href="map.css" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />

    <script type="text/jscript" src="https://dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=5&s=1"></script>

    <script type="text/jscript">
      var map = null;
      var searchControl = null;
      var routeControl = null;
      var rightMenu = null;
      var customerName = "";
      var customerAddress = "";
      var customerPushPin = null; 
      var showingRoute = false;
      var showRouteWindow = false;
      var route = null;
      
      /*
      * Loads the intitial map, and get the Latitude, Longitude and Address data from CRM's form.
      */
      function GetMap()
      {        
		//Get data from CRM to load up Map
		// Try to get lat&long from the CRM
		var lat = window.parent.Xrm.Page.getAttribute("address1_latitude").getValue();
		var lon = window.parent.Xrm.Page.getAttribute("address1_longitude").getValue();
		var zoom = 14;

		//alert("lat:" + lat );
		//alert("lon:" + lon );

		//Get adress from CRM
		var addressLine1 = window.parent.Xrm.Page.getAttribute("address1_line1").getValue();
		var postalCode = window.parent.Xrm.Page.getAttribute("address1_postalcode").getValue();
		var city = window.parent.Xrm.Page.getAttribute("address1_city").getValue();
		var stateOrProvince = window.parent.Xrm.Page.getAttribute("address1_stateorprovince").getValue();
		var country = window.parent.Xrm.Page.getAttribute("address1_country").getValue();

		//Compose customer address
		customerAddress = addressLine1+", "+postalCode+" "+city+" ("+stateOrProvince+")";

		if(country != null)
		{
			customerAddress += ", " + country;
		}

		//Get Customer name from CRM's form
		customerName = window.parent.Xrm.Page.getAttribute("name").getValue();
         
		map = new VEMap('myMap');
		map.LoadMap();

		//Attach mouse event in order to show context menu
		map.AttachEvent("onclick",MouseHandler);		 

		//Adds a search control
		AddSearch();

		//Place customer's pushpin
		if (lat == null)
		{         
			SetMessage("The Organization geoposition is not set, please place a pushpin (right click)");
			map.Find(null,customerAddress,null,null,0,10,true,true,true,true,FindCallBack);                        
			//If customer's lat&long are null we try to find the location 
		}
		else
		{
			map.SetCenterAndZoom(new VELatLong(lat, lon), zoom);                  
			PlacePushPin(map.GetCenter(),false);
		}             
      }               
      
      /*
      * Retrieve the results from map.Find() and set customer's pushpin
      */
      function FindCallBack(shapeLayer, results, positions, moreResults, e)
      {
        if(positions != null && positions.length > 0)
        {            
            map.SetCenterAndZoom(new VELatLong(positions[0].LatLong.Latitude,positions[0].LatLong.Longitude),15);
            PlacePushPin(map.GetCenter(),true);
        }
      }
      
      /*
      * Mouse event handler
      */
      function MouseHandler(e)
      {
        if (e.eventName == "onclick")
        {
            if (e.rightMouseButton)
            {
                //Right click, show context menu
                ShowContextMenu(e);
            }
        }
      }
      
      /* 
      * Adds the context menu to the map.
      */
      function ShowContextMenu(e)
      {
        if (rightMenu != null) RemoveRightMenu();
        
        var LL = map.PixelToLatLong(new VEPixel(e.mapX, e.mapY));
        rightMenu = document.createElement("div");                
        rightMenu.id = "rightMenu";
        rightMenu.style.position="absolute";               
        rightMenu.style.top = e.clientY;                
        rightMenu.style.left = e.clientX;                              
        var html="";
        if (e.elementID==null)  
        {
            //The right click is not over customer's pushpin      
            html = "<ul><li><a onclick='PlacePushPin(new VELatLong("+LL.Latitude+","+LL.Longitude+"),true);'>Set customer position</a></li>";
        }
        else
        {
            //The right click is over customer's pushpin (is the only element on the map)
            html = "<ul><li><a onclick=\"RemovePushPin();\">Remove Organization position</a></li>"
                    + "<li><a onclick=\"AddRouteControl(1);\">Get Route to Organization from...</a></li>"
                    + "<li><a onclick=\"AddRouteControl(0);\">Get Route from Organization to...</a></li>";
        }
        
        //If we are showing a route give more options about the route
        if (showingRoute) 
        {
            html += "<li><a onclick='ShowRouteWindow();'>Show Route info...</a></li>";
            html += "<li><a onclick='map.DeleteRoute();showingRoute=false;route=null;'>Clear Route</a></li></ul>";
        }
        else
        {
            html += "</ul>"
        }               
        rightMenu.innerHTML = html;  
        rightMenu.onmouseleave = RemoveRightMenu;
        map.HideInfoBox();
        map.AddControl(rightMenu);               
      }
      
      /*
      * Hides the context menu
      */
      function RemoveRightMenu()
      {
        if (rightMenu != null) 
        {
            map.DeleteControl(rightMenu);
            rightMenu = null;
        }
      }
      
      /*
      * Place customer's pushpin and conditionally updates CRM lat&long
      */
      function PlacePushPin(LatLong,update)
      {
        if(customerPushPin != null)
            RemovePushPin();
            
        customerPushPin = new VEShape(VEShapeType.Pushpin,LatLong);
        customerPushPin.SetTitle(customerName);
        customerPushPin.SetCustomIcon("<img src='a422_/Travel/images/pin.png'/>");
        map.AddShape(customerPushPin);        
        RemoveRightMenu();
        map.SetCenter(customerPushPin.GetPoints()[0]);
        SetMessage("Right click on the pushpin for options");
        
        //Update CRM Lat&Lon
        if (update)
        {
            window.parent.Xrm.Page.getAttribute("address1_latitude").setValue(customerPushPin.GetPoints()[0].Latitude);
            window.parent.Xrm.Page.getAttribute("address1_longitude").setValue(customerPushPin.GetPoints()[0].Longitude);
        }
      }
      
      /*
      * Removes customer's pushpin and set CRM lat & long to null value
      */
      function RemovePushPin()
      {
        if (customerPushPin != null)
        {
            map.DeleteShape(customerPushPin);
            customerPushPin=null;
            SetMessage("The customer geoposition is not set, please place a pushpin (right click)");
            
        //Update CRM Lat&Lon
            window.parent.Xrm.Page.getAttribute("address1_latitude").setValue(null);
            window.parent.Xrm.Page.getAttribute("address1_longitude").setValue(null);           
        }   
      }
      
      /*
      * Adds the search control to the Map
      */
      function AddSearch()         
      {            
        if (searchControl == null)            
        {               
            searchControl = document.createElement("div");                
            searchControl.id = "searchControl";               
            searchControl.style.top ="10px";                
            searchControl.style.left = "100px";
            searchControl.style.width = "70%";                                         
            searchControl.innerHTML = "<label id='expand' class='windowControl' onclick='expandSearch()'>[-]</label>"
                +"<label id='txtMessages'></label>"
                +"<div id='searchField'><input type='text' name='txtWhere' id='txtWhere' class='txt' value='"
                +customerAddress+"'/><input type='button' id='btnFind' value='Find' name='Find'"
                +" onclick='SearchLocation(txtWhere.value)' class='btn'/></div>";                            
            map.AddControl(searchControl);               
        }
      }      
      
      /*
      * Expands or Shrink the search control
      */
      function expandSearch()
      {
        control = document.getElementsByName("searchField")[0];
        if(control !=null)
            if (control.style.visibility!="hidden")
            {
                searchControl.style.height="10px";
                control.style.visibility="hidden";                
                document.getElementsByName("expand")[0].innerText = "[+]";
            }
            else
            {
                searchControl.style.height="";
                control.style.visibility="visible";                
                document.getElementsByName("expand")[0].innerText = "[-]";
            }        
      }
      
      /*
      * Remove the search control
      */
      function RemoveSearch()
      {
        if (searchControl != null) 
        {
            map.DeleteControl(searchControl);
            searchControl = null;
        }
      }            
      
      /*
      *Find a location using the map
      */
      function SearchLocation(whereText)
      {
        try 
        {
            map.Find(null,whereText);
        } 
        catch (e)
        {
            alert(e.message);
        }
      }
      
      /*
      * Changes the message label
      */
      function SetMessage(messageText)
      {
        document.getElementsByName("txtMessages")[0].innerText = messageText;
      }
      
      /*
      * Shows the route control
      */
      function AddRouteControl(toCustomer)         
      {
                  
        if (routeControl == null)            
        {   
            var label="";              
            if (toCustomer==1) label = "Enter origin address...";
            else label = "Enter destination address...";
            routeControl = document.createElement("div");                
            routeControl.id = "routeControl";                          
            routeControl.style.top ="100px";                
            routeControl.style.left = "100px";
            routeControl.style.width = "70%";                                         
            routeControl.innerHTML = "<label onclick='RemoveRouteControl()' class='windowControl'>[X] </label>" 
                +"<label id='routeMessages'>"+label+"</label>"
                +"<label> | Kilometers </label><input type='checkbox' name='chkKM' />"
                +"<label> | Show in new window </label><input type='checkbox' name='chkShowRouteWindow' />"
                +"<div id='routeField' class='dialogField'><input type='text' name='txtRoute' id='txtRoute' class='txt' value='"
                +"'/><input type='button' id='btnGetRoute' value='Get Route' name='btnGetRoute'"
                +" onclick='GetRoute(txtRoute.value,"+toCustomer+",chkKM.status,chkShowRouteWindow.status)' class='btn'/></div>";                            
            map.AddControl(routeControl);               
        }
      }
      
      /*
      * Hides the route control
      */
      function RemoveRouteControl()
      {
        if (routeControl != null) 
        {
            map.DeleteControl(routeControl);
            routeControl =null;
        }
      }
      
      /*
      * Obtains and shows the route information
      */
      function GetRoute(where,toCustomer,km, newWindow)
      {
        //Hides the route selection
        RemoveRouteControl();
        
        var distanceUnit = VEDistanceUnit.Miles;
        if (km) distanceUnit = VEDistanceUnit.Kilometers;
        if (toCustomer==1)
        {
            //Gets a route to the customer
            map.GetRoute(where,customerPushPin.GetPoints()[0],distanceUnit,null,OnGotRoute);
        }
        else
        {
            //Gets a route from the customer
            map.GetRoute(customerPushPin.GetPoints()[0],where,distanceUnit,null,OnGotRoute);
        }
        showingRoute=true;
        showRouteWindow = newWindow;
      }
      
      /*
      * Get route callback. Opens a new dialog with the route information if selected
      */
      function OnGotRoute(r)
      {
        route = r;
        if (showRouteWindow)
        {
           ShowRouteWindow();           
        }
      }
      
      /*
      * Opens ShowRoute.htm in a new dialog  and pass the route information as a param
      */
      function ShowRouteWindow()
      {
        if(route != null)
            window.showModelessDialog("ShowRoute.htm",route,"center:yes;resizable:yes;dialogWidth:500px;dialogHeight:600px");
      }
      
      
    </script>

</head>
<body onload="GetMap();">
      <div id='myMap' style="position:absolute; width:100%; height:360px;"></div>
</body>
</html>
